import java.util.*;
import java.io.*;

public class FileIOTest {
    // demonstrates using FileReader, and FileWriter for 
    // reading a file character by character. 
    // and writing a files character by character and writing with Strings.
  public static void main(String[] args) throws FileNotFoundException, IOException {
      String filename, outfilename;

      // Quit if there are not two arguments.
      if (args.length != 2) {
	  System.out.println(
             "Usage: java FileIOTest <input file name> <output file name>");
	  return;
      }

      // first two arguments are file input and file output
      filename = args[0];
      outfilename = args[1];

      // check out default character encoding type. 
      System.out.println("Default character encoding type is " +
			 System.getProperty("file.encoding"));

      // read characters from a file one by one, and write
      // them back into the outputfile.
      FileReader in = new FileReader( new File(filename));
      FileWriter out = new FileWriter(new File(outfilename));
      System.out.println("Reading characters from file " + filename 
			 + " and writing to file " + outfilename);
      int c;
      // c contains the current character. (cast it to char to see is value
      //                                    as a char)
      c = in.read();
      // c == -1 means we've reached the end of the file.
      while (c != -1) {
	  System.out.println("Read a '" + (char) c + "'");
	  out.write(c);
	  c = in.read();
      }
      in.close();
      out.close();

      outfilename = "double" + outfilename; 
      in = new FileReader( new File(filename));
      out = new FileWriter(new File(outfilename));
      System.out.println("Reading characters from file " + filename 
			 + " and writing each char duplicated to file " + outfilename);
      // c contains the current character. (cast it to char to see is value
      //                                    as a char)
      c = in.read();
      // c == -1 means we've reached the end of the file.
      String temp;
      while (c != -1) {
	  temp = String.valueOf((char) c);
	  out.write(temp + temp);
	  c = in.read();
      }
      in.close();
      out.close();
  }
}
