import java.util.*;
import java.io.*;

public class UseScanner {
    // demonstrates use of scanner for keyboard and file input.
    // also demonstrates writing integers to a file. 
  public static void main(String[] args) throws FileNotFoundException, IOException {

      // First, echo back string entered by user on keyboard.
      System.out.println("Demonstration of using Scanner.java");
      Scanner in = new Scanner(System.in);
      System.out.println("Enter a string, followed by return:");
      String line = in.nextLine();
      System.out.println("You entered the following line (not including  quotes)");
      System.out.println("\"" + line + "\"");

      // Now get a filename to read unless it was given in a command line argument.
      System.out.println();
      String filename;
      if (args.length==0) {
	  System.out.println("Enter a filename to read:");
	  filename = in.nextLine();	  
      }
      else filename = args[0];

      // read from a file line by line, printing out to screen.
      System.out.println("Reading file " + filename + " and printing to screen.");
      Scanner filescan = new Scanner(new File(filename));
      while (filescan.hasNextLine())
	  System.out.println(filescan.nextLine());
      filescan.close();


      // this section reads Integers from a file, and writes incremented
      // ints to another file. 
      // Ints are assumed to be separated by white space (spaces, tabs, 
      //  and newlines. The new file separates ints by spaces.
      filename = "intlist.txt";
	  //      System.out.println("Enter a filename of integers to read:");
	  //      filename = in.nextLine();	  
      String outfilename = "tempnum.txt";

      filescan = new Scanner(new File(filename)); 
      FileWriter out = new FileWriter(new File(outfilename));
      System.out.println("Reading integers from file " + filename 
			 + " and writing incremented integers into  file " + outfilename);
      String stringInt;
      int c;
      // main loop reading ints, and writing incremented versions
      // into the new file. 
      while (filescan.hasNextInt()) {
	  c = filescan.nextInt();
	  stringInt = String.valueOf(c);
	  System.out.println("Read a " + stringInt);
	  out.write(String.valueOf(c+1) + " " );
      }
      out.write("\n");
      in.close();
      out.close();
  }
}
